<?php
/*-------------------------------------------------------
*
*   Expoll.
*   Copyright © 2013 Alexei Lukin
*
*--------------------------------------------------------
*
*   Official site: http://kerbystudio.ru
*   Contact e-mail: kerby@kerbystudio.ru
*
---------------------------------------------------------
*/

class PluginExpoll_ActionAdmin extends PluginExpoll_Inherit_ActionAdmin
{
    protected function RegisterEvent()
    {
        $this->AddEventPreg('/^expoll-blocks$/i', 'EventExpollBlocks');
        parent::RegisterEvent();
    }

    /**
     * Какие топики голосуются в блоках
     *
     * @param $bAbstain Воздерживается ли пользователь?
     */
    protected function EventExpollBlocks()
    {
        if (!$this->oUserCurrent || ($this->oUserCurrent && !$this->oUserCurrent->isAdministrator()))
        {
            $this->Message_AddErrorSingle($this->Lang_Get('not_access'));
            return;
        }

        $iDeleteTopicId = (int)getRequest('delete', null, 'get');
        if ($iDeleteTopicId)
        {
            $this->Security_ValidateSendForm();

            $oBlockData = $this->PluginExpoll_Expoll_GetBlockById($iDeleteTopicId);
            if (!$oBlockData)
                $this->Message_AddErrorSingle($this->Lang_Get('plugin.expoll.error_poll_not_found'));
            else
            {
                $oBlockData->delete();
                $this->Message_AddNoticeSingle($this->Lang_Get('plugin.expoll.msg_poll_deleted'));
            }
        }

        $aBlocks = array();
        foreach (Config::Get('plugin.expoll.poll_blocks') as $sId => $sValue)
        {
            $oBlock['id'] = $sId;
            $oBlock['title'] = $this->Lang_Get($sValue);
            $aBlockData = $this->PluginExpoll_Expoll_GetBlockItemsByFilter(
                array(
                    'block_id' => $sId,
                    'date_start <=' => date('Y-m-d H:i:s'),
                    'date_finish >=' => date('Y-m-d H:i:s'),
                    '#order' => array('date_start' => 'asc'),
                )
            );
            $oBlock['data'] = $aBlockData;

            if (count($aBlockData) > 0)
                $aBlocks[] = $oBlock;
        }

        $this->Viewer_Assign('aExpollBlocks', $aBlocks);

        $this->SetTemplate(PluginExpoll::GetTemplateFilePath(__CLASS__, 'actions/ActionAdmin/expoll_blocks.tpl'));
    }

    /** Обертка для голосования */
    protected function EventExpollVote()
    {
        $this->Viewer_SetResponseAjax('json');

        $this->ExpollDoVoting(false);
    }

    /** Обертка для воздерживания */
    protected function EventExpollVoteAbstain()
    {
        $this->Viewer_SetResponseAjax('json');

        $this->ExpollDoVoting(true);
    }

}

?>