<?php
/*-------------------------------------------------------
*
*   Expoll.
*   Copyright © 2013 Alexei Lukin
*
*--------------------------------------------------------
*
*   Official site: http://kerbystudio.ru
*   Contact e-mail: kerby@kerbystudio.ru
*
---------------------------------------------------------
*/

class PluginExpoll_BlockExpoll extends Block
{

    public function Exec()
    {
        $aTopicId = $this->GetParam('topic_id');
        if (!$aTopicId)
            $aTopicId = array();
        else if (!is_array($aTopicId))
            $aTopicId = array($aTopicId);

        $sBlockId = $this->GetParam('block_id');
        if ($sBlockId)
        {
            $aBlockData = $this->PluginExpoll_Expoll_GetBlockItemsByFilter(
                array(
                    'block_id' => $sBlockId,
                    'date_start <=' => date('Y-m-d H:i:s'),
                    'date_finish >=' => date('Y-m-d H:i:s'),
                )
            );

            foreach ($aBlockData as $oBlockData)
            {
                $aTopicId[] = $oBlockData->getTopicId();
            }
        }

        $aTopicId=array_unique($aTopicId);

        if (count($aTopicId)==0)
            return;

        do
        {
            $sKey = array_rand($aTopicId);
            $oTopic = $this->Topic_GetTopicById($aTopicId[$sKey]);

            /** Топик не задан или не является голосованием */
            if (!$oTopic || ($oTopic && !$oTopic->getExpoll()))
            {
                /** Убираем из массива */
                $oTopic = null;
                unset($aTopicId[$sKey]);
            }
        } while (!$oTopic && count($aTopicId) > 0);

        /** Топик не задан или не является голосованием */
        if (!$oTopic || ($oTopic && !$oTopic->getExpoll()))
        {
            /** Блок не показывается */
            return;
        }


        $this->Viewer_Assign("oExpollTopic", $oTopic);
        $this->Viewer_Assign("sExpollContent", $this->PluginExpoll_Expoll_GetExpollContent($oTopic, true));
    }
}

?>