<?php
/*-------------------------------------------------------
*
*   Expoll.
*   Copyright © 2012 Alexei Lukin
*
*--------------------------------------------------------
*
*   Official site: http://kerbystudio.ru
*   Contact e-mail: kerby@kerbystudio.ru
*
---------------------------------------------------------
*/

class PluginExpoll_HookExpoll extends Hook
{
    public function RegisterHook()
    {
        $this->AddHook('template_form_add_topic_topic_begin', 'InjectPollEditor');
        $this->AddHook('template_form_add_topic_photoset_begin', 'InjectPollEditor');
        $this->AddHook('template_form_add_topic_link_begin', 'InjectPollEditor');

        $this->AddHook('template_topic_content_begin', 'InjectPollContentBefore');
        $this->AddHook('template_topic_content_end', 'InjectPollContentAfter');

        $this->AddHook('check_topic_fields', 'CheckTopicFields');
        $this->AddHook('topic_add_show', 'PreparePollEditor');
        $this->AddHook('topic_add_after', 'PrepareTopicDataAdd');
        $this->AddHook('topic_edit_show', 'PreparePollEditor');
        $this->AddHook('topic_edit_before', 'PrepareTopicData');

        $this->AddHook('template_admin_action_item', 'AdminAction');
    }

    /**
     * Добавляем пункт меню в админку
     * @return mixed
     */
    public function AdminAction()
    {
        return $this->Viewer_Fetch(PluginExpoll::GetTemplateFilePath(__CLASS__ , 'admin_action_item.tpl'));
    }

    /**
     * Подготавливает данные топика для редактирования или добавления
     *
     * @param $aParam
     */
    public function PreparePollEditor($aParam)
    {
        $oTopic = isset($aParam['oTopic']) ? $aParam['oTopic'] : null;

        /** Почему же хуку проверки полей не передается топик?!?? */
        global $oExpollEditTopic;
        $oExpollEditTopic = $oTopic;

        /** @var $bExpollEditingDisabled Топик редактируется? */
        $bExpollEditingDisabled = false;
        if ($oTopic && $oTopic->getExpoll() && $oTopic->getQuestionCountVote() > 0)
        {
            $bExpollEditingDisabled = true;
        }

        if ($oTopic)
        {
            $oTopic->setExpollEditingDisabled($bExpollEditingDisabled);
            if ($oTopic->getExpollClosed() && !$oTopic->getExpollClosedRaw())
                $this->Topic_UpdateTopic($oTopic);
        }

        $oUserCurrent = $this->User_GetUserCurrent();

        /** @var $bExpollAllowBlockEdit Возможно ли редактирование помещения в блок */
        $bExpollAllowBlockEdit = $this->PluginExpoll_Expoll_CanPutInBlock($oUserCurrent) && count(Config::Get('plugin.expoll.poll_blocks')) > 0;
        $this->Viewer_Assign("bExpollAllowBlockEdit", $bExpollAllowBlockEdit);

        /** @var $aQuestions получаем массив ответов из POST */
        $aQuestions = (array)getRequest('expoll_questions', array('text' => array(), 'id' => array()), 'post');


        /** Топик редактируется, поэтому в POST ничего нет */
        if ($oTopic && count($aQuestions['text']) == 0)
        {
            $aQuestions = array();
            $aArr = $this->PluginExpoll_Expoll_GetQuestionItemsByTopicId($oTopic->getId(), array('#order' => array('order' => 'asc')));
            foreach ($aArr as $oQuestion)
            {
                $aQuestions['text'][] = $oQuestion->getText();
                $aQuestions['id'][] = $oQuestion->getId();
            }

            $_REQUEST['expoll_questions'] = $aQuestions;
            $_REQUEST['expoll_multivote'] = $oTopic->getMultivote();
            $_REQUEST['expoll_multivote_count'] = $oTopic->getMultivoteCount();
            $_REQUEST['expoll_multivote_use_order'] = $oTopic->getMultivoteUseOrder();
            $_REQUEST['expoll_question_title'] = $oTopic->getExpollTitle();
            $_REQUEST['expoll_questions_after'] = $oTopic->getExpollQuestionsAfter();
            $_REQUEST['expoll_timelimit'] = $oTopic->getExpollTimelimit();
            if ($oTopic->getExpollTimelimit())
                $_REQUEST['expoll_timelimit_finish'] = date("d.m.Y H:i:s", strtotime($oTopic->getExpollTimelimitFinish()));
            else
                $_REQUEST['expoll_timelimit_finish'] = date("d.m.Y H:i:s", time() + Config::Get('plugin.expoll.limit_days') * 24 * 60 * 60);
        }

        if (!getRequest('expoll_timelimit_finish', null, 'post') && !$oTopic)
        {
            $_REQUEST['expoll_timelimit'] = 0;
            $_REQUEST['expoll_timelimit_finish'] = date("d.m.Y H:i:s", time() + Config::Get('plugin.expoll.limit_days') * 24 * 60 * 60);
        }

        if ($bExpollAllowBlockEdit)
        {
            $aBlockData = array();

            if ($oTopic)
                $aBlockData = $this->PluginExpoll_Expoll_GetBlockItemsByTopicId($oTopic->getId());

            if (count($aBlockData) > 0 && !getRequest('expoll_date_start', null, 'post'))
            {
                $_REQUEST['expoll_use_block'] = 1;

                foreach (Config::Get('plugin.expoll.poll_blocks') as $sBlockId => $sTitle)
                {
                    $_REQUEST['expoll_date_finish'][$sBlockId] = date("d.m.Y H:i:s", time() + Config::Get('plugin.expoll.block_days') * 24 * 60 * 60);
                    $_REQUEST['expoll_date_start'][$sBlockId] = date("d.m.Y H:i:s");
                }

                foreach ($aBlockData as $oBlockData)
                {
                    $_REQUEST['expoll_block_id'][$oBlockData->getBlockId()] = $oBlockData->getBlockId();

                    $_REQUEST['expoll_date_finish'][$oBlockData->getBlockId()] = date("d.m.Y H:i:s", strtotime($oBlockData->getDateFinish()));
                    $_REQUEST['expoll_date_start'][$oBlockData->getBlockId()] = date("d.m.Y H:i:s", strtotime($oBlockData->getDateStart()));
                }

            }
            else
            {
                if (!getRequest('expoll_date_start', null, 'post'))
                {
                    $_REQUEST['expoll_use_block'] = 0;
                    $_REQUEST['expoll_block_id'] = array();

                    foreach (Config::Get('plugin.expoll.poll_blocks') as $sBlockId => $sTitle)
                    {
                        $_REQUEST['expoll_date_finish'][$sBlockId] = date("d.m.Y H:i:s", time() + Config::Get('plugin.expoll.block_days') * 24 * 60 * 60);
                        $_REQUEST['expoll_date_start'][$sBlockId] = date("d.m.Y H:i:s");
                    }
                }
            }
        }

        /** Костыль для замены стандартного функционала опросов */
        global $bCalledQuestionAdd;
        if ($bCalledQuestionAdd && count($aQuestions['text']) == 0)
        {
            $aQuestions = array(
                'text' => array('', ''),
                'id' => array('', ''),
            );
            $_REQUEST['expoll_questions'] = $aQuestions;

        }

        $this->Viewer_Assign("bExpollEditingDisabled", $bExpollEditingDisabled);

        /** Указываем шаблон добавления нового варианта опроса */
        $this->Viewer_Assign('aPollTemplates', array('new_question' => $this->Viewer_Fetch(PluginExpoll::GetTemplateFilePath(__CLASS__, 'inject_new_question.tpl'))));
    }

    /**
     * Функция проверки полей голосования
     *
     * @param $aParam
     */
    public function CheckTopicFields($aParam)
    {
        $bOk = $aParam['bOk'];
        if (!$bOk)
            return;

        /** Костыль непередачи переменной топика в хук проверки */
        global $oExpollEditTopic;
        $oTopic = $oExpollEditTopic;

        /** @var $aQuestions получаем варианты из POST */
        $aQuestions = (array)getRequest('expoll_questions', array('text' => array(), 'id' => array()), 'post');

        /** @var $aTestQuestions убираем пустые варианты опроса */
        $aTestQuestions = array_unique(array_filter(array_map('trim', $aQuestions['text'])));

        /** Если они есть - ошибка */
        if (count($aTestQuestions) != count($aQuestions['text']))
        {
            $this->Message_AddError($this->Lang_Get('plugin.expoll.error_empty_questions'), $this->Lang_Get('error'));
            $bOk = false;
        }

        /** Количество текстовок, почему-то, не совпадает с количеством ИД */
        if ($bOk && (count($aQuestions['text']) != count($aQuestions['id'])))
        {
            $this->Message_AddError($this->Lang_Get('system_error'), $this->Lang_Get('error'));
            $bOk = false;
        }

        /** Автоматическое закрытие голосования */
        if ($bOk && (((int)getRequest('expoll_timelimit', null, 'post')) == 1) && (!$oTopic || ($oTopic && !$oTopic->getExpollClosed())))
        {
            if (strtotime((string)getRequest('expoll_timelimit_finish')) < time())
            {
                $this->Message_AddError($this->Lang_Get('plugin.expoll.error_finishdate_less_now'), $this->Lang_Get('error'));
                $bOk = false;
            }
        }

        /** Количество текстовок, почему-то, не совпадает с количеством ИД */
        $sExpollTitle = (string)getRequest('expoll_question_title', '', 'post');
        if ($bOk && (!empty($sExpollTitle) && mb_strlen($sExpollTitle) > Config::Get('plugin.expoll.max_title_length')))
        {
            $this->Message_AddError($this->Lang_Get('plugin.expoll.error_title_length'), $this->Lang_Get('error'));
            $bOk = false;
        }

        if ($bOk)
        {
            /** В опросе должно быть минимум два варианта... */
            if (count($aQuestions['text']) > 0 && count($aQuestions['text']) < 2)
            {
                $this->Message_AddError($this->Lang_Get('plugin.expoll.error_minimum_two'), $this->Lang_Get('error'));
                $bOk = false;
            }

        }

        if ($bOk)
        {
            /** Проверяем на нормально число вариантов ответа */
            if ((string)getRequest('expoll_multivote', 0, 'post') && !(is_numeric((string)getRequest('expoll_multivote_count', 0, 'post')) && ((int)getRequest('expoll_multivote_count', 0, 'post') >= 0)))
            {
                $this->Message_AddError($this->Lang_Get('plugin.expoll.error_wrong_multivote_value'), $this->Lang_Get('error'));
                $bOk = false;
            }

        }

        $oUserCurrent = $this->User_GetUserCurrent();

        $aBlocksRequest = (array)getRequest('expoll_block_id', array(), 'post');
        if ($bOk && count(Config::Get('plugin.expoll.poll_blocks')) && count($aBlocksRequest) > 0)
        {
            foreach ($aBlocksRequest as $sBlockId)
            {
                if (!$this->PluginExpoll_Expoll_CanPutInBlockSingle($oUserCurrent, $sBlockId))
                {
                    $this->Message_AddError($this->Lang_Get('plugin.expoll.error_cant_use_block'), $this->Lang_Get('error'));
                    $bOk = false;
                }
            }
        }

        if ($bOk)
        {
            foreach ($aQuestions['text'] as $key => $sValue)
            {
                /** Почему-то нет ИД варианта, соответсвующего тексту варианта */
                if (!isset($aQuestions['id'][$key]))
                {
                    $this->Message_AddError($this->Lang_Get('system_error'), $this->Lang_Get('error'));
                    $bOk = false;
                    break;
                }

                /** Проверяем, а принадлежит ли вариант вопроса с переданным ИД нашему редактируемому топику? */
                $iQuestionId = $aQuestions['id'][$key];
                if ($oTopic && $iQuestionId)
                {
                    $oOldQuestion = $this->PluginExpoll_Expoll_GetQuestionByTopicIdAndId($oTopic->getId(), $iQuestionId);
                    if (!$oOldQuestion)
                    {
                        $this->Message_AddError($this->Lang_Get('system_error'), $this->Lang_Get('error'));
                        $bOk = false;
                        break;
                    }
                }

                /** Проверяем на длину варианта */
                if ((mb_strlen(trim($sValue)) < Config::Get('plugin.expoll.min_question_length')) || (mb_strlen(trim($sValue)) > Config::Get('plugin.expoll.max_question_length')))
                {
                    $this->Message_AddError($this->Lang_Get('plugin.expoll.error_question_length'), $this->Lang_Get('error'));
                    $bOk = false;
                    break;
                }
            }
        }

        $aParam['bOk'] = $bOk;
    }

    /**
     * Находит в массиве вариант опроса по его ИД
     *
     * @param $aOldQuestions
     * @param $iId
     * @return null
     */
    protected function FindOldQuestion($aOldQuestions, $iId)
    {
        $oOldQuestion = null;

        foreach ($aOldQuestions as $oQuestion)
        {
            if ($oQuestion->getId() == $iId)
            {
                $oOldQuestion = $oQuestion;
                break;
            }
        }

        return $oOldQuestion;
    }

    /**
     * Подготавливает топик для сохранения
     *
     * @param $aParam
     */
    public function PrepareTopicData($aParam)
    {
        $oTopic = isset($aParam['oTopic']) ? $aParam['oTopic'] : null;

        if (!$oTopic)
            return;

        if ($oTopic->getQuestionCountVote() == 0)
        {
            $aQuestions = (array)getRequest('expoll_questions', array('text' => array(), 'id' => array()), 'post');
            $aOldQuestions = array();

            if ($oTopic->getId())
                $aOldQuestions = $this->PluginExpoll_Expoll_GetQuestionItemsByTopicId($oTopic->getId(), array('#order' => array('order' => 'asc')));

            /** @var $aNotFound Варианты, которых больше нет в списке. Надо их найти и удалить. */
            $aNotFound = array();
            foreach ($aOldQuestions as $oQuestion)
            {
                if (!in_array($oQuestion->getId(), $aQuestions['id']))
                {
                    $aNotFound[] = $oQuestion;
                    $oQuestion->delete();
                }
            }

            $aChangedText = array();

            $aResultQuestions = array();

            $iCurrOrder = 0;
            $bWasQuestions = false;

            /** Создаем варианты и сохраняем */
            foreach ($aQuestions['text'] as $key => $sValue)
            {
                $sValue = trim($sValue);

                $bWasQuestions = true;

                $oOldQuestion = $this->FindOldQuestion($aOldQuestions, $aQuestions['id'][$key]);

                if ($oOldQuestion)
                {
                    if ($oOldQuestion->getText() != $sValue)
                    {
                        $oOldQuestion->setText($sValue);
                        $aChangedText[$oOldQuestion->getId()] = true;
                    }

                    $oCurrentQuestion = $oOldQuestion;
                }
                else
                {
                    $oCurrentQuestion = Engine::GetEntity('PluginExpoll_ModuleExpoll_EntityQuestion');
                    $oCurrentQuestion->setText($sValue);
                }

                $oCurrentQuestion->setTopicId($oTopic->getId());
                $oCurrentQuestion->setOrder($iCurrOrder++);
                $oCurrentQuestion = $oCurrentQuestion->save();
                $aResultQuestions[$oCurrentQuestion->getId()] = $oCurrentQuestion;
            }

            $oTopic->setExpoll($bWasQuestions);

            $oTopic->setExpollTitle((string)getRequest('expoll_question_title', '', 'post'));
            $oTopic->setExpollQuestionsAfter(getRequest('expoll_questions_after'), 0, 'post');

            $oTopic->setMultivote(getRequest('expoll_multivote', 0, 'post'));
            $oTopic->setMultivoteCount((int)getRequest('expoll_multivote_count', null, 'post'));
            $oTopic->setMultivoteUseOrder(getRequest('expoll_multivote_use_order', 0, 'post'));
            if ($oTopic->getMultivoteCount() > count($aResultQuestions))
                $oTopic->setMultivoteCount(count($aResultQuestions));
            $iTotalWeight = 1;
            if ($oTopic->getMultivote() && $oTopic->getMultivoteUseOrder())
            {
                $iCount = $oTopic->getMultivoteCount() > 0 ? $oTopic->getMultivoteCount() : count($aResultQuestions);
                $iTotalWeight = $iCount; //((1.0+$iCount)/2)*$iCount;
            }
            $oTopic->setMultivoteTotalWeight($iTotalWeight);

            /** Пересортировка вариантов для показа */
            $aResults = $oTopic->getQuestionAnswers();
            $aOutRes = array();
            foreach ($aResults as $key => $oResult)
            {
                $iOrder = false;
                foreach ($aResultQuestions as $ikey => $oQuestion)
                {
                    if ($oQuestion->getText() == $oResult['text'])
                    {
                        $iOrder = $oQuestion->getOrder();
                        break;
                    }
                }

                if ($iOrder !== false)
                    $aOutRes[$iOrder] = $oResult;
            }

            ksort($aOutRes);
            $oTopic->setQuestionAnswers($aOutRes);

        }
        else
        {
            /** Репдактировался топик с созданым голосованием */
            if ($oTopic->getExpoll() && !$oTopic->getExpollEditingDisabled())
            {
                $this->Message_AddError($this->Lang_Get('plugin.expoll.error_edit_already_voted'), $this->Lang_Get('error'), true);
            }
        }

        $oTopic->setExpollTimelimit(getRequest('expoll_timelimit', 0, 'post'));
        $oTopic->setExpollTimelimitFinish(getRequest('expoll_timelimit_finish', null, 'post'));

        if (($oTopic->getExpollTimelimit() && $oTopic->getExpollClosed() && (strtotime($oTopic->getExpollTimelimitFinish()) > time())) || (!$oTopic->getExpollTimelimit() && $oTopic->getExpollClosed()))
        {
            $oTopic->setExpollClosed(0);
        }

        $aBlockData = $this->PluginExpoll_Expoll_GetBlockItemsByTopicId($oTopic->getId());

        if (count($aBlockData) > 0)
        {
            foreach ($aBlockData as $oBlockData)
                $oBlockData->delete();
        }

        if (getRequest('expoll_use_block', null, 'post'))
        {
            $aBD = (array)getRequest('expoll_block_id', array(), 'post');

            $aDS = (array)getRequest('expoll_date_start', array(), 'post');
            $aDF = (array)getRequest('expoll_date_finish', array(), 'post');

            foreach ($aBD as $sId)
            {
                $oBlockData = LS::GetEntity('PluginExpoll_ModuleExpoll_EntityBlock');
                $oBlockData->setTopicId($oTopic->getId());
                $oBlockData->setBlockId($sId);
                $oBlockData->setDateStart(date('Y-m-d H:i:s', strtotime($aDS[$sId])));
                $oBlockData->setDateFinish(date('Y-m-d H:i:s', strtotime($aDF[$sId])));
                $oBlockData->save();
            }
        }

        $this->PluginExpoll_Expoll_CalculateResults($oTopic, array());
    }

    /**
     * Врапер для именно добавления
     *
     * @param $aParam
     */
    public function PrepareTopicDataAdd($aParam)
    {
        $this->PrepareTopicData($aParam);
        $this->Topic_UpdateTopic($aParam['oTopic']);
    }

    /**
     * Вставляем редактор опроса в редактор топика
     *
     * @param $aParam
     * @return mixed
     */
    public function InjectPollEditor($aParam)
    {
        return $this->Viewer_Fetch(PluginExpoll::GetTemplateFilePath(__CLASS__, 'inject_poll_editor.tpl'));
    }

    /**
     * Вставляем в топик либо голосование, либо показывам результаты
     *
     * @param $aParam
     * @return mixed
     */
    public function InjectPollContentBefore($aParam)
    {
        $oTopic = $aParam['topic'];
        if (!$oTopic || !$oTopic->getExpoll())
            return;

        if ($oTopic->getExpollClosed() && !$oTopic->getExpollClosedRaw())
            $this->Topic_UpdateTopic($oTopic);

        if ($oTopic->getExpollQuestionsAfter())
            return;

        return $this->PluginExpoll_Expoll_GetExpollContent($oTopic);
    }

    /**
     * Вставляем в топик либо голосование, либо показывам результаты
     *
     * @param $aParam
     * @return mixed
     */
    public function InjectPollContentAfter($aParam)
    {
        $oTopic = $aParam['topic'];
        if (!$oTopic || !$oTopic->getExpoll())
            return;

        if (!$oTopic->getExpollQuestionsAfter())
            return;

        $bTopicList = $aParam['bTopicList'];

        if ($bTopicList && ($oTopic->getTextShort() != $oTopic->getText()))
            return;

        return $this->PluginExpoll_Expoll_GetExpollContent($oTopic);
    }

}

?>