<?php
/*-------------------------------------------------------
*
*   Expoll.
*   Copyright © 2013 Alexei Lukin
*
*--------------------------------------------------------
*
*   Official site: http://kerbystudio.ru
*   Contact e-mail: kerby@kerbystudio.ru
*
---------------------------------------------------------
*/

class PluginExpoll_ModuleTopic_EntityTopic extends PluginExpoll_Inherit_ModuleTopic_EntityTopic
{
    /**
     * Сохраняет флаг запрещения редактирования
     *
     * @param $data
     */
    public function setExpollEditingDisabled($data)
    {
        $this->setExtraValue('expoll_editing_disabled', $data ? 1 : 0);
    }

    /**
     * Сохраняет флаг закрытия голосования
     *
     * @param $data
     */
    public function setExpollClosed($data)
    {
        $this->setExtraValue('expoll_closed', $data ? 1 : 0);
    }

    /**
     * Получает флаг запрещения редактирования
     *
     * @param $data
     */
    public function getExpollEditingDisabled()
    {
        return $this->getExtraValue('expoll_editing_disabled');
    }

    /**
     * Сохраняет флаг многовариантного опроса
     *
     * @param $data
     */
    public function setMultivote($data)
    {
        $this->setExtraValue('expoll_multivote', $data ? 1 : 0);
    }

    /**
     * Сохраняет флаг лимитированного по времени опроса
     *
     * @param $data
     */
    public function setTimelimit($data)
    {
        $this->setExtraValue('expoll_timelimit', $data ? 1 : 0);
    }

    /**
     * Сохраняет флаг лимитированного по времени опроса
     *
     * @param $data
     */
    public function setTimelimitFinish($data)
    {
        $this->setExtraValue('expoll_timelimit_finish', $data);
    }

    /**
     * Сохраняет флаг использования порядка опроса
     *
     * @param $data
     */
    public function setMultivoteUseOrder($data)
    {
        $this->setExtraValue('expoll_multivote_use_order', $data ? 1 : 0);
    }

    /**
     * Устанавливает предмет опроса
     *
     * @param $data
     */
    public function setExpollTitle($data)
    {
        $this->setExtraValue('expoll_title', $data);
    }

    /**
     * Устанавливает флаг размещения опроса
     *
     * @param $data
     */
    public function setExpollQuestionsAfter($data)
    {
        $this->setExtraValue('expoll_questions_after', $data ? 1 : 0);
    }

    /**
     * Сохраняет максимальное количество мультивариантного опроса
     *
     * @param $data
     */
    public function setMultivoteCount($data)
    {
        $this->setExtraValue('expoll_multivote_count', $data);
    }

    /**
     * Устанавливает общий вес вопроса
     *
     * @param $data
     */
    public function setMultivoteTotalWeight($data)
    {
        $this->setExtraValue('expoll_multivote_total_weight', $data);
    }

    /**
     * Получает флаг многовариантного опроса
     *
     * @return bool
     */
    public function getMultivote()
    {
        return $this->getExtraValue('expoll_multivote') ? true : false;
    }

    /**
     * Получает флаг лимитированного по времени опроса
     *
     * @return bool
     */
    public function getExpollTimelimit()
    {
        return $this->getExtraValue('expoll_timelimit') ? true : false;
    }

    /**
     * Получает дату лимитированного по времени опроса
     *
     * @return string
     */
    public function getExpollTimelimitFinish()
    {
        return $this->getExtraValue('expoll_timelimit_finish');
    }

    /**
     * Получает флаг лимитированного по времени опроса
     *
     * @return bool
     */
    public function setExpollTimelimit($data)
    {
        return $this->setExtraValue('expoll_timelimit', $data ? 1 : 0);
    }

    /**
     * Получает дату лимитированного по времени опроса
     *
     * @return string
     */
    public function setExpollTimelimitFinish($data)
    {
        return $this->setExtraValue('expoll_timelimit_finish',$data);
    }

    /**
     * Получает флаг многовариантного опроса
     *
     * @return bool
     */
    public function getExpollTitle()
    {
        return (string)$this->getExtraValue('expoll_title');
    }

    /**
     * Получает флаг размещения опроса
     *
     * @return bool
     */
    public function getExpollQuestionsAfter()
    {
        return $this->getExtraValue('expoll_questions_after') ? 1 : 0;
    }


    /**
     * Получает флаг использования многовариантного опроса
     *
     * @return bool
     */
    public function getMultivoteUseOrder()
    {
        return $this->getExtraValue('expoll_multivote_use_order') ? true : false;
    }

    /**
     * Получает количество вариантов ответов в опросе
     *
     * @return mixed
     */
    public function getMultivoteCount()
    {
        return $this->getExtraValue('expoll_multivote_count');
    }

    /**
     * Получает общий вес
     *
     * @return mixed
     */
    public function getMultivoteTotalWeight()
    {
        return $this->getExtraValue('expoll_multivote_total_weight');
    }

    /**
     * Получает сообщение об общем количестве вариантов
     *
     * @return mixed
     */
    public function getMultivoteCountMsg()
    {
        return $this->Lang_Get('plugin.expoll.msg_vote_max_count', array('count' => $this->getExtraValue('expoll_multivote_count')));
    }

    public function getExpollClosedRaw()
    {
        return $this->getExtraValue('expoll_closed')?true:false;
    }

    public function getExpollClosed()
    {
        if ($this->getExpollTimelimit() && !$this->getExtraValue('expoll_closed'))
        {
            if (strtotime($this->getExpollTimelimitFinish()) < time())
            {
                $this->setExpollClosed(1);
            }
        }

        return $this->getExtraValue('expoll_closed');
    }

    /**
     * Устанавливает массив результатов опроса
     *
     * @param $data
     */
    public function setQuestionAnswers($data)
    {
        if ($this->getExpoll())
            $this->setExtraValue('answers', $data);
    }

    /**
     * Обертка
     * Возвращает общее число принявших участие в опросе в топике-опросе
     *
     * @return int|null
     */
    public function getQuestionCountVote()
    {
        if (!$this->getExpoll() && !$this->getType() == 'question')
            return null;

        $sSaveType = $this->getType();
        $this->setType('question');
        $res = parent::getQuestionCountVote();
        $this->setType($sSaveType);
        return $res;
    }

    /**
     * Обертка
     * Устанавливает общее число принявших участие в опросе в топике-опросе
     *
     * @param int $data
     */
    public function setQuestionCountVote($data)
    {
        if (!$this->getExpoll() && !$this->getType() == 'question')
            return;

        $sSaveType = $this->getType();
        $this->setType('question');
        parent::setQuestionCountVote($data);
        $this->setType($sSaveType);
    }

    /**
     * Обертка
     * Возвращает число воздержавшихся от участия в опросе в топике-опросе
     *
     * @return int|null
     */
    public function getQuestionCountVoteAbstain()
    {
        if (!$this->getExpoll() && !$this->getType() == 'question')
            return null;

        $sSaveType = $this->getType();
        $this->setType('question');
        $res = parent::getQuestionCountVoteAbstain();
        $this->setType($sSaveType);
        return $res;
    }

    /**
     * Обертка
     * Устанавливает число воздержавшихся от участия в опросе в топике-опросе
     *
     * @param int $data
     * @return mixed
     */
    public function setQuestionCountVoteAbstain($data)
    {
        if (!$this->getExpoll() && !$this->getType() == 'question')
            return;

        $sSaveType = $this->getType();
        $this->setType('question');
        parent::setQuestionCountVoteAbstain($data);
        $this->setType($sSaveType);
    }

    /**
     * Обертка
     * Возвращает варианты ответа в топике-опрос
     *
     * @param bool $bSortVote
     * @return array|null
     */
    public function getQuestionAnswers($bSortVote = false)
    {
        if (!$this->getExpoll() && !$this->getType() == 'question')
            return null;

        $sSaveType = $this->getType();
        $this->setType('question');
        $res = parent::getQuestionAnswers($bSortVote);
        $this->setType($sSaveType);
        return $res;
    }

    /**
     * Возвращает в процентах количество проголосовавших за конкретный вариант
     *
     * @param int $sIdAnswer ID варианта
     * @return int|string
     */
    public function getQuestionAnswerPercent($sIdAnswer)
    {
        if (!$this->getExpoll())
            return parent::getQuestionAnswerPercent($sIdAnswer);

        if ($aAnswers = $this->getQuestionAnswers())
        {
            if (isset($aAnswers[$sIdAnswer]))
            {
                $iCountAll = $this->getQuestionCountVote();
                $iTotalWeight = $this->getMultivoteTotalWeight() * $iCountAll;

                if ($iCountAll == 0)
                {
                    return 0;
                }
                else
                {
                    return number_format(round($aAnswers[$sIdAnswer]['count'] * 100 / $iTotalWeight, 1), 1, '.', '');
                }
            }
        }
    }
}

?>
