<?php
/*-------------------------------------------------------
*
*   Expoll.
*   Copyright © 2013 Alexei Lukin
*
*--------------------------------------------------------
*
*   Official site: http://kerbystudio.ru
*   Contact e-mail: kerby@kerbystudio.ru
*
---------------------------------------------------------
*/

class PluginExpoll_ModuleTopic_MapperTopic extends PluginExpoll_Inherit_ModuleTopic_MapperTopic
{
    /**
     * Записывает дополнительное поле в БД при обновлении
     *
     * @param PluginExpoll_ModuleTopic_EntityTopic $oTopic
     * @return mixed
     */
    public function UpdateTopic(ModuleTopic_EntityTopic $oTopic)
    {
        parent::UpdateTopic($oTopic);
        $sql = "UPDATE " . Config::Get('db.table.topic') . "
			SET
			 topic_expoll=?
			WHERE
				topic_id = ?d
		";
        $this->oDb->query($sql, $oTopic->getExpoll(), $oTopic->getId());

        return true;
    }

    /**
     * Записывает дополнительное поле в БД вопросов при добавлении
     *
     * @param PluginExpoll_ModuleTopic_EntityTopic $oTopic
     * @return bool
     */
    public function AddTopic(ModuleTopic_EntityTopic $oTopic)
    {
        $iId = parent::AddTopic($oTopic);

        if ($iId)
        {
            $oTopic->setId($iId);
            $this->UpdateTopic($oTopic);
            return $iId;
        }
        return false;
    }

}

?>