var ls = ls ||
{};

ls.expoll = (function ($) {
    this.templates = [];
    this.focus_after = false;
    this.multivote_count = [];

    this.deleteQuestion = function (e) {
        if (confirm(ls.lang.get('plugin.expoll.confirm_delete_question'))) {
            var poll = $(e.target).parents('.expoll-body');
            var q = $($(e.target).parents('.expoll-poll li')[0])
            var arr = poll.find('li');
            if (arr.length == 1) {
                poll.slideUp(200, function () {
                    poll.prev('.js-expoll-add-poll').show();
                    q.remove();
                });
            }
            else {
                q.slideUp(200, function () {
                    q.remove();
                });
            }
        }
    }

    this.addQuestion = function (e, param) {
        var newItem = $(ls.expoll.templates['new_question']);
        var ul = $($(e.target).parents('.expoll-editor').find('ul.expoll-poll')[0]);
        var arr = ul.find('li');
        if (arr.length != 0) {
            newItem.css('display', 'none');
        }
        newItem.appendTo(ul);
        newItem = $(newItem);
        newItem.find('a.js-expoll-delete-question').on('click', ls.expoll.deleteQuestion);
        if (arr.length != 0) {
            newItem.slideDown(200, function () {
                if (ls.expoll.focus_after) {
                    ls.expoll.focus_after.focus();
                    ls.expoll.focus_after = false;
                }
                else
                    newItem.find('input.expoll-text').focus();

            });
        }
        else
            newItem.find('input.expoll-text').focus();
    }

    this.toggleFields = function (obj) {
        obj = $(obj);
        var mcount = $(obj.parents('.expoll-field')[0]).next();
        if (obj.is(':checked')) {
            mcount.slideDown();
        }
        else
            mcount.slideUp();
    }

    this.changeMultivote = function (obj) {
        ls.expoll.toggleFields(obj);
    }

    this.changeBlock = function (obj) {
        ls.expoll.toggleFields(obj);
    }

    this.changeTimelimit = function (obj) {
        if ($(obj).is(':checked')) {
            if (!confirm(ls.lang.get('plugin.expoll.confirm_timelimit')))
                return;
        }
        ls.expoll.toggleFields(obj);
    }

    this.changeVote = function (obj) {
        obj = $(obj);
        var poll = $(obj.parents('.expoll-voting-section')[0]);
        var checked = poll.find("input.expoll-vote-checkbox[type=checkbox]:checked").length;
        var topicId = poll.data('topic_id');
        var maxCount = ls.expoll.multivote_count[topicId];
        if (maxCount > 0 && checked > maxCount) {
            obj.removeAttr('checked');
            ls.msg.error(null, ls.lang.get('plugin.expoll.error_max_answer_count') + maxCount);
        }
    }

    this.updateMultivoteOrder = function (poll, maxCount) {
        poll = $(poll);

        var curCount = 0;
        $(poll).find('li').each(function (v, e) {
            e = $(e);
            if ((maxCount != 0) && (curCount < maxCount)) {
                e.find('input[type="checkbox"]').attr('checked', 'checked').show().removeAttr('disabled');
                curCount++;
            }
            else {
                if (maxCount != 0)
                    e.find('input[type="checkbox"]').removeAttr('checked').hide().attr('disabled', 'disabled');
                else
                    e.find('input[type="checkbox"]').attr('checked', 'checked').hide();
            }
        });

    }

    this.doVote = function (obj, abstain) {
        obj = $(obj);
        var poll = $(obj.parents('.expoll-voting-section')[0]);
        var form = $(poll.find('.expoll-form')[0]);
        var checked = poll.find("input.expoll-vote-checkbox[type=checkbox]:checked").length;
        var topicId = poll.data('topic_id');
        form.addClass('loader');
        var event = 'expoll-vote/';
        if (abstain)
            var event = 'expoll-vote-abstain/';

        ls.ajaxSubmit(aRouter.ajax + event, form, function (result) {
            form.removeClass('loader');
            if (!result) {
                ls.msg.error(null, 'System error. Please try later.');
            }
            else if (result.bStateError) {
                ls.msg.error(null, result.sMsg);
            } else {
                if (result.sMsg)
                    ls.msg.notice(null, result.sMsg);

                poll.slideUp(200, function () {
                    poll.html(result.sResult);
                    poll.find('.poll-sort').trigger('click');
                    poll.slideDown(200);
                });
            }
        }.bind(this));
    }

    this.findElement = function (par, ids) {
        return par.find('[id*=' + ids + ']');
    }

    this.switchResult = function (obj, iTopicId) {
        obj = $(obj);
        var par = $(obj.parents('.expoll')[0]);

        if (!par.length)
            return ls.expoll.oldSwitchResult(obj, iTopicId);

        if (ls.expoll.findElement(par, 'poll-result-sort').css('display') == 'none') {
            ls.expoll.findElement(par, 'poll-result-original').hide();
            ls.expoll.findElement(par, 'poll-result-sort-').show();
            obj.toggleClass('active');
        } else {
            ls.expoll.findElement(par, 'poll-result-sort').hide();
            ls.expoll.findElement(par, 'poll-result-original').show();
            obj.toggleClass('active');
        }
        return false;
    };

    this.vote = function () {
        ls.expoll.doVote(this, false);
    }

    this.abstain = function () {
        ls.expoll.doVote(this, true);
    }

    this.init = function () {
        ls.expoll.oldSwitchResult = ls.poll.switchResult;
        ls.poll.switchResult = ls.expoll.switchResult;

        $('.datetime-picker').datetimepicker({
            changeMonth: true,
            changeYear: true,
            dateFormat: 'dd.mm.yy',
            timeFormat: 'HH:mm:ss',
            dayNamesMin: ['Вс', 'Пн', 'Вт', 'Ср', 'Чт', 'Пт', 'Сб'],
            monthNames: ['Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'],
            monthNamesShort: ['Янв','Фев','Мар','Апр','Май','Июн','Июл','Авг','Сен','Окт','Ноя','Дек'],
            firstDay: 1,
            timeOnlyTitle: 'Выберите время',
            timeText: 'Время',
            hourText: 'Часы',
            minuteText: 'Минуты',
            secondText: 'Секунды',
            currentText: 'Теперь',
            closeText: 'Закрыть',
            showSecond: true
        });

        $('.js-expoll-delete-question').on('click', this.deleteQuestion);
        $('.js-expoll-add-question').on('click', this.addQuestion);
        $('.js-expoll-vote').on('click', this.vote);
        $('.js-expoll-abstain').on('click', this.abstain);
        $('.js-expoll-add-poll').on('click', function (e) {
            var poll = $(e.target).next('.expoll-body');

            $(e.target).hide();
            poll.slideDown(200, function () {
                poll.find('.js-expoll-add-question').trigger('click', 123);
                var first = $(poll.find('input.expoll-text')[0]);
                ls.expoll.focus_after = first;
                poll.find('.js-expoll-add-question').trigger('click');
            });
        });

        $('.expoll-voting-section').each(function (k, e) {
            e = $(e);
            if (e.data('multivote_count') > 0)
                ls.expoll.updateMultivoteOrder(e, e.data('multivote_count'));
        });

        $('.poll').each(function (k, e) {
            e = $(e);
            e.find('.poll-sort').trigger('click');
        });

    }

    return this;
}).call(ls.expoll ||
    {}, jQuery);

jQuery(document).ready(function () {
    ls.expoll.init();
});
